Subject: Re: bug#62575: 29.0.60; Tabs are not showing the right names of the buffers

From: Eli Zaretskii <[email-masked]>
Date: Sat, 01 Apr 2023 17:07:05 +0300

> Date: Sat, 1 Apr 2023 13:19:51 +0200
> Cc: [email-masked]
> From: Claudio Grondi <[email-masked]>
> 
> Below the steps required to reproduce the bug:
> 
> 1. ~ $ emacs -Q
> 2. Menu -> Options -> Show/Hide -> Tab Bar (gives Tab *scratch*)
> 3. 1x click on rightmost * in the Tab Bar to create a new Tab (gives 2x 
> *scratch* Tabs)
> 4. With the rightmost (second) Tab open ~/.emacs (gives 1x *scratch* and 
> 1x .emacs Tabs)
> 5. 2x click on rightmost * in the Tab Bar to create twp new Tabs (gives 
> 1x *scratch* and 3x .emacs Tabs)
> 6. with rightmost Tab active kill the .emacs buffer [C-x k] (the Tabs 
> label turns  to *scratch the other two Tabs labeled .emacs keep their 
> labels, so there are 1x *scratch*, 2x .emacs, 1x *scratch* Tabs)
> 7. *click the second Tab labeled* .emacs' (result: the label of the Tab 
> turns to *Messages*. the Tab Bar shows *scratch* *Messages* .emacs 
> *scratch* )
> 
> The bug: the third Tab still keeps its  .emacs  label, the click on the 
> second Tab labeled  .emacs  did not show the .emacs file, but the buffer 
> *Messages*.

After looking at the code, I'm not sure this is a bug.  The tab names
are just labels, although they are conveniently set to the name of the
buffer in the window to be selected when the tab is current.  But
otherwise they are just labels.  When you click on the tab, its name
is updated to reflect the buffer shown in the selected window, so I
think Emacs is behaving correctly, although it might be a bit
unexpected.

Juri, am I right?  If not, where is the code that's supposed to update
the labels when some buffers or windows are deleted or renamed?